/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.35 Revision 1.124
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.35 2009/05/23 01:08:26 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.124 2012/04/04 16:37:50 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 2|3|4) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
21 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
22 ;; 37 ;;
23 *) 38 release)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
25 MY_PV="${PV}"
26 ;; 40 ;;
27esac 41esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="dev-util/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
56RDEPEND="
57 !<x11-libs/qt-assistant-${PV}
58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-core-${PV}
60 !>x11-libs/qt-core-${PV}-r9999
61 !<x11-libs/qt-dbus-${PV}
62 !>x11-libs/qt-dbus-${PV}-r9999
63 !<x11-libs/qt-declarative-${PV}
64 !>x11-libs/qt-declarative-${PV}-r9999
65 !<x11-libs/qt-demo-${PV}
66 !>x11-libs/qt-demo-${PV}-r9999
67 !<x11-libs/qt-gui-${PV}
68 !>x11-libs/qt-gui-${PV}-r9999
69 !<x11-libs/qt-multimedia-${PV}
70 !>x11-libs/qt-multimedia-${PV}-r9999
71 !<x11-libs/qt-opengl-${PV}
72 !>x11-libs/qt-opengl-${PV}-r9999
73 !<x11-libs/qt-openvg-${PV}
74 !>x11-libs/qt-openvg-${PV}-r9999
75 !<x11-libs/qt-phonon-${PV}
76 !>x11-libs/qt-phonon-${PV}-r9999
77 !<x11-libs/qt-qt3support-${PV}
78 !>x11-libs/qt-qt3support-${PV}-r9999
79 !<x11-libs/qt-script-${PV}
80 !>x11-libs/qt-script-${PV}-r9999
81 !<x11-libs/qt-sql-${PV}
82 !>x11-libs/qt-sql-${PV}-r9999
83 !<x11-libs/qt-svg-${PV}
84 !>x11-libs/qt-svg-${PV}-r9999
85 !<x11-libs/qt-test-${PV}
86 !>x11-libs/qt-test-${PV}-r9999
87 !<x11-libs/qt-webkit-${PV}
88 !>x11-libs/qt-webkit-${PV}-r9999
89 !<x11-libs/qt-xmlpatterns-${PV}
90 !>x11-libs/qt-xmlpatterns-${PV}-r9999
91"
92
29S=${WORKDIR}/${MY_P} 93S=${WORKDIR}/${MY_P}
30 94
31HOMEPAGE="http://www.qtsoftware.com/"
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
33
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43# @FUNCTION: qt4-build_pkg_setup 95# @FUNCTION: qt4-build_pkg_setup
44# @DESCRIPTION: 96# @DESCRIPTION:
45# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 97# Sets up PATH and LD_LIBRARY_PATH.
46qt4-build_pkg_setup() { 98qt4-build_pkg_setup() {
47 # EAPI=2 ebuilds set use-deps, others need this: 99 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
48 if [[ $EAPI != 2 ]]; then 100
49 # Make sure debug setting corresponds with qt-core (bug 258512) 101 # Protect users by not allowing downgrades between releases
50 if [[ $PN != "qt-core" ]]; then 102 # Downgrading revisions within the same release should be allowed
51 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 103 if has_version '>'${CATEGORY}/${P}-r9999; then
52 ~x11-libs/qt-core-${PV} debug" 104 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
105 eerror
106 eerror "Sanity check to keep you from breaking your system:"
107 eerror " Downgrading Qt is completely unsupported and will break your system!"
108 eerror
109 die "aborting to save your system"
110 else
111 ewarn "Downgrading Qt is completely unsupported and will break your system!"
53 fi 112 fi
113 fi
54 114
55 # Check USE requirements 115 if [[ ${PN} == qt-webkit ]]; then
56 qt4-build_check_use 116 eshopts_push -s extglob
117 if is-flagq '-g?(gdb)?([1-9])'; then
118 echo
119 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
120 ewarn "You may experience really long compilation times and/or increased memory usage."
121 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
122 ewarn "For more info check out bug #307861"
123 echo
57 fi 124 fi
58 # Set up installation directories 125 eshopts_pop
59 QTBASEDIR=/usr/$(get_libdir)/qt4 126 fi
60 QTPREFIXDIR=/usr
61 QTBINDIR=/usr/bin
62 QTLIBDIR=/usr/$(get_libdir)/qt4
63 QTPCDIR=/usr/$(get_libdir)/pkgconfig
64 QTDATADIR=/usr/share/qt4
65 QTDOCDIR=/usr/share/doc/qt-${PV}
66 QTHEADERDIR=/usr/include/qt4
67 QTPLUGINDIR=${QTLIBDIR}/plugins
68 QTSYSCONFDIR=/etc/qt4
69 QTTRANSDIR=${QTDATADIR}/translations
70 QTEXAMPLESDIR=${QTDATADIR}/examples
71 QTDEMOSDIR=${QTDATADIR}/demos
72 127
73 PLATFORM=$(qt_mkspecs_dir)
74
75 PATH="${S}/bin:${PATH}" 128 PATH="${S}/bin${PATH:+:}${PATH}"
129 if [[ ${CHOST} != *-darwin* ]]; then
76 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 130 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
131 else
132 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
133 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
134 # platform detection. Note: needs to come before any directories to
135 # avoid extract failure.
136 [[ ${CHOST} == *-apple-darwin* ]] && \
137 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
138 ${QT4_EXTRACT_DIRECTORIES}"
139 fi
77 140
78 if ! version_is_at_least 4.1 $(gcc-version) ; then 141 if ! version_is_at_least 4.1 $(gcc-version); then
79 ewarn "Using a GCC version lower than 4.1 is not supported!" 142 ewarn "Using a GCC version lower than 4.1 is not supported."
80 echo
81 ebeep 3
82 fi 143 fi
83
84 if use custom-cxxflags; then
85 echo
86 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
87 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
88 ewarn "recommend to unset this useflag. But you are free to experiment with it."
89 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
90 ewarn "for breakfast. ;-) "
91 echo
92 fi
93
94} 144}
95 145
96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 146# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DESCRIPTION: 147# @DESCRIPTION:
98# Arguments for build_target_directories. Takes the directories, in which the 148# Arguments for build_target_directories. Takes the directories in which the
99# code should be compiled. This is a space-separated list 149# code should be compiled. This is a space-separated list.
100 150
101# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 151# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
102# @DESCRIPTION: 152# @DESCRIPTION:
103# Space separated list including the directories that will be extracted from Qt 153# Space-separated list including the directories that will be extracted from
104# tarball 154# Qt tarball.
105 155
106# @FUNCTION: qt4-build_src_unpack 156# @FUNCTION: qt4-build_src_unpack
107# @DESCRIPTION: 157# @DESCRIPTION:
108# Unpacks the sources 158# Unpacks the sources.
109qt4-build_src_unpack() { 159qt4-build_src_unpack() {
110 local target targets licenses 160 setqtenv
111 if version_is_at_least 4.5 ${PV} ; then 161
112 licenses="LICENSE.GPL3 LICENSE.LGPL" 162 case ${QT4_BUILD_TYPE} in
113 else 163 live)
114 licenses="LICENSE.GPL2 LICENSE.GPL3" 164 git-2_src_unpack
115 fi 165 ;;
116 for target in configure ${licenses} projects.pro \ 166 release)
167 local tarball="${MY_P}.tar.gz" target= targets=
168 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
117 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 169 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
118 ${QT4_EXTRACT_DIRECTORIES}; do 170 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
171 do
119 targets="${targets} ${MY_P}/${target}" 172 targets+="${MY_P}/${target} "
120 done 173 done
121 174
122 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 175 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
123 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 176 tar -xzf "${DISTDIR}/${tarball}" ${targets}
124 177 eend $? || die "failed to unpack"
125 case "${PV}" in
126 4.4.?)
127 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
128 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
129 ;; 178 ;;
130 esac 179 esac
131
132 # Be backwards compatible for now
133 if [[ $EAPI != 2 ]]; then
134 qt4-build_src_prepare
135 fi
136} 180}
137 181
182# @ECLASS-VARIABLE: PATCHES
183# @DEFAULT_UNSET
184# @DESCRIPTION:
185# PATCHES array variable containing all various patches to be applied.
186# This variable is expected to be defined in global scope of ebuild.
187# Make sure to specify the full path. This variable is utilised in
188# src_unpack/src_prepare phase, based on EAPI.
189#
190# @CODE
191# PATCHES=( "${FILESDIR}/mypatch.patch"
192# "${FILESDIR}/patches_folder/" )
193# @CODE
138 194
139# @FUNCTION: qt4-build_src_prepare 195# @FUNCTION: qt4-build_src_prepare
140# @DESCRIPTION: 196# @DESCRIPTION:
141# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 197# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
142# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 198# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
143qt4-build_src_prepare() { 199qt4-build_src_prepare() {
144 cd "${S}" 200 setqtenv
201
202 if [[ ${QT4_BUILD_TYPE} == live ]]; then
203 QTDIR="." ./bin/syncqt || die "syncqt failed"
204 fi
205
206 if version_is_at_least 4.7; then
207 # fix libX11 dependency on non X packages
208 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
209 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
210
211 qt_assistant_cleanup
212 fi
213
214 if use aqua; then
215 # provide a proper macx-g++-64
216 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
217
218 sed -e '/^CONFIG/s:app_bundle::' \
219 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
220 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
221 fi
145 222
146 if [[ ${PN} != qt-core ]]; then 223 if [[ ${PN} != qt-core ]]; then
147 skip_qmake_build_patch 224 skip_qmake_build
148 skip_project_generation_patch 225 skip_project_generation
149 symlink_binaries_to_buildtree 226 symlink_binaries_to_buildtree
150 fi 227 fi
151 228
152 if ! use custom-cxxflags;then 229 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
153 # Don't let the user go too overboard with flags. 230 # qmake bus errors with -O2 or -O3 but -O1 works
154 strip-flags 231 # Bug 373061
155 replace-flags -O3 -O2 232 replace-flags -O[23] -O1
156 fi 233 fi
157 234
158 # Bug 178652 235 # Bug 178652
159 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 236 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
160 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 237 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
161 append-flags -fno-gcse 238 append-flags -fno-gcse
162 fi 239 fi
163 240
241 if use_if_iuse c++0x; then
242 echo
243 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
244 ewarn "this is an official standard, some of the reverse dependencies"
245 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
246 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
247 ewarn "disabled."
248 echo
249 append-flags -std=c++0x
250 fi
251
164 # Unsupported old gcc versions - hardened needs this :( 252 # Unsupported old gcc versions - hardened needs this :(
165 if [[ $(gcc-major-version) -lt "4" ]] ; then 253 if [[ $(gcc-major-version) -lt 4 ]]; then
166 ewarn "Appending -fno-stack-protector to CXXFLAGS" 254 ewarn "Appending -fno-stack-protector to CXXFLAGS"
167 append-cxxflags -fno-stack-protector 255 append-cxxflags -fno-stack-protector
168 # Bug 253127 256 # Bug 253127
169 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 257 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
170 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 258 -i mkspecs/common/g++.conf || die
171 fi 259 fi
260
261 # Bug 261632
262 if use ppc64; then
263 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
264 append-flags -mminimal-toc
265 fi
266
267 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
268 sed -e "/^SYSTEM_VARIABLES=/i \
269 CC='$(tc-getCC)'\n\
270 CXX='$(tc-getCXX)'\n\
271 CFLAGS='${CFLAGS}'\n\
272 CXXFLAGS='${CXXFLAGS}'\n\
273 LDFLAGS='${LDFLAGS}'\n" \
274 -i configure \
275 || die "sed SYSTEM_VARIABLES failed"
276
277 # Respect CC, CXX, LINK and *FLAGS in config.tests
278 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
279 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
280 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
281 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
282 || die "sed config.tests failed"
283
284 # Strip predefined CFLAGS from mkspecs (bug 312689)
285 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
172 286
173 # Bug 172219 287 # Bug 172219
288 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
289
290 if [[ ${CHOST} == *-darwin* ]]; then
291 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
292 # crippled (by design) :/
293 local mac_gpp_conf=
294 if [[ -f mkspecs/common/mac-g++.conf ]]; then
295 # qt < 4.8 has mac-g++.conf
296 mac_gpp_conf="mkspecs/common/mac-g++.conf"
297 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
298 # qt >= 4.8 has g++-macx.conf
299 mac_gpp_conf="mkspecs/common/g++-macx.conf"
300 else
301 die "no known conf file for mac found"
302 fi
303 sed \
174 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 304 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
175 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 305 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
176 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 306 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
177 -e "s:X11R6/::" \ 307 -e "s:-arch\s\w*::g" \
178 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 308 -i ${mac_gpp_conf} \
309 || die "sed ${mac_gpp_conf} failed"
179 310
180 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 311 # Fix configure's -arch settings that appear in qmake/Makefile and also
181 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 312 # fix arch handling (automagically duplicates our -arch arg and breaks
182 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 313 # pch). Additionally disable Xarch support.
183 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 314 local mac_gcc_confs="${mac_gpp_conf}"
315 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
316 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
317 fi
318 sed \
319 -e "s:-arch i386::" \
320 -e "s:-arch ppc::" \
321 -e "s:-arch x86_64::" \
322 -e "s:-arch ppc64::" \
323 -e "s:-arch \$i::" \
324 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
325 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
326 -e "s:-Xarch_x86_64::g" \
327 -e "s:-Xarch_ppc64::g" \
328 -i configure ${mac_gcc_confs} \
329 || die "sed -arch/-Xarch failed"
184 330
331 # On Snow Leopard don't fall back to 10.5 deployment target.
332 if [[ ${CHOST} == *-apple-darwin10 ]]; then
333 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
334 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
335 -i configure ${mac_gpp_conf} \
336 || die "sed deployment target failed"
337 fi
338 fi
339
340 # this one is needed for all systems with a separate -liconv, apart from
341 # Darwin, for which the sources already cater for -liconv
342 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
343 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
344 -i config.tests/unix/iconv/iconv.pro \
345 || die "sed iconv.pro failed"
346 fi
347
348 # we need some patches for Solaris
349 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
350 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
351 # use GCC over SunStudio
352 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
353 # do not flirt with non-Prefix stuff, we're quite possessive
354 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
355 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
356
357 base_src_prepare
185} 358}
186 359
187# @FUNCTION: qt4-build_src_configure 360# @FUNCTION: qt4-build_src_configure
188# @DESCRIPTION: 361# @DESCRIPTION:
189# Default configure phase 362# Default configure phase
190qt4-build_src_configure() { 363qt4-build_src_configure() {
364 setqtenv
191 365
192 myconf="$(standard_configure_options) ${myconf}"
193
194 echo ./configure ${myconf}
195 ./configure ${myconf} || die "./configure failed"
196}
197
198# @FUNCTION: qt4-build_src_compile
199# @DESCRIPTION: Actual compile phase
200qt4-build_src_compile() {
201 # Be backwards compatible for now
202 if [[ $EAPI != 2 ]]; then
203 qt4-build_src_configure
204 fi
205
206 build_directories "${QT4_TARGET_DIRECTORIES}"
207}
208
209# @FUNCTION: qt4-build_src_install
210# @DESCRIPTION:
211# Perform the actual installation including some library fixes.
212qt4-build_src_install() {
213 install_directories "${QT4_TARGET_DIRECTORIES}"
214 install_qconfigs
215 fix_library_files
216}
217
218# @FUNCTION: standard_configure_options
219# @DESCRIPTION:
220# Sets up some standard configure options, like libdir (if necessary), whether
221# debug info is wanted or not.
222standard_configure_options() {
223 local myconf="" 366 local conf="
224 367 -prefix ${QTPREFIXDIR}
225 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 368 -bindir ${QTBINDIR}
226 369 -libdir ${QTLIBDIR}
227 # Disable visibility explicitly if gcc version isn't 4 370 -docdir ${QTDOCDIR}
228 if [[ "$(gcc-major-version)" -lt "4" ]]; then 371 -headerdir ${QTHEADERDIR}
229 myconf="${myconf} -no-reduce-exports" 372 -plugindir ${QTPLUGINDIR}
230 fi 373 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
231 374 -datadir ${QTDATADIR}
232 # precompiled headers doesn't work on hardened, where the flag is masked. 375 -translationdir ${QTTRANSDIR}
233 if use pch; then 376 -sysconfdir ${QTSYSCONFDIR}
234 myconf="${myconf} -pch" 377 -examplesdir ${QTEXAMPLESDIR}
235 else 378 -demosdir ${QTDEMOSDIR}
236 myconf="${myconf} -no-pch" 379 -opensource -confirm-license
237 fi 380 -shared -fast -largefile -stl -verbose
238 381 -nomake examples -nomake demos"
239 if use debug; then
240 myconf="${myconf} -debug -no-separate-debug-info"
241 else
242 myconf="${myconf} -release -no-separate-debug-info"
243 fi
244 382
245 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 383 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
246 # $(tc-arch). Therefore we convert it to supported values. 384 # $(tc-arch). Therefore we convert it to supported values.
247 case "$(tc-arch)" in 385 case "$(tc-arch)" in
248 amd64) myconf="${myconf} -arch x86_64" ;; 386 amd64|x64-*) conf+=" -arch x86_64" ;;
387 ppc-macos) conf+=" -arch ppc" ;;
249 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 388 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
389 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
390 x86-macos) conf+=" -arch x86" ;;
250 x86|x86-*) myconf="${myconf} -arch i386" ;; 391 x86|x86-*) conf+=" -arch i386" ;;
251 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 392 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
252 hppa|sh) myconf="${myconf} -arch generic" ;; 393 hppa|sh) conf+=" -arch generic" ;;
253 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 394 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
254 esac 395 esac
255 396
256 # Bug 261412 Qt configure detects archs by uname 397 conf+=" -platform $(qt_mkspecs_dir)"
257 case "$(tc-arch)" in
258 ppc) myconf="${myconf} -platform linux-g++-32";;
259 esac
260 398
261 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 399 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
262 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
263 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
264 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
265 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
266 -demosdir ${QTDEMOSDIR} -silent -fast
267 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
268 -reduce-relocations -nomake examples -nomake demos"
269
270 # Make eclass 4.5.{1,2} ready
271 case "${MY_PV}" in
272 4.5.1 | 4.5.2)
273 myconf="${myconf} -opensource"
274 ;;
275 esac
276 400
401 # debug/release
402 if use debug; then
403 conf+=" -debug"
404 else
405 conf+=" -release"
406 fi
407 conf+=" -no-separate-debug-info"
408
409 # exceptions USE flag
410 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
411
412 # disable RPATH on Qt >= 4.8 (bug 380415)
413 version_is_at_least 4.8 && conf+=" -no-rpath"
414
415 # precompiled headers don't work on hardened, where the flag is masked
416 conf+=" $(qt_use pch)"
417
418 # -reduce-relocations
419 # This flag seems to introduce major breakage to applications,
420 # mostly to be seen as a core dump with the message "QPixmap: Must
421 # construct a QApplication before a QPaintDevice" on Solaris.
422 # -- Daniel Vergien
423 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
424
425 # this one is needed for all systems with a separate -liconv, apart from
426 # Darwin, for which the sources already cater for -liconv
427 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
428 conf+=" -liconv"
429 fi
430
431 if use_if_iuse glib; then
432 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
433 # avoid the -pthread argument
434 conf+=" ${glibflags//-pthread}"
435 unset glibflags
436 fi
437
438 if use_if_iuse qpa; then
439 echo
440 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
441 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
442 ewarn "disable it before reporting any bugs related to this useflag."
443 echo
444 conf+=" -qpa"
445 fi
446
447 if use aqua; then
448 # On (snow) leopard use the new (frameworked) cocoa code.
449 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
450 conf+=" -cocoa -framework"
451 # We need the source's headers, not the installed ones.
452 conf+=" -I${S}/include"
453 # Add hint for the framework location.
454 conf+=" -F${QTLIBDIR}"
455
456 # We are crazy and build cocoa + qt3support :-)
457 if use qt3support; then
458 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
459 -i configure || die
460 fi
461 else
462 conf+=" -no-framework"
463 fi
464 else
465 # freetype2 include dir is non-standard, thus pass it to configure
466 conf+=" $(pkg-config --cflags-only-I freetype2)"
467 fi
468
277 echo "${myconf}" 469 conf+=" ${myconf}"
470 myconf=
471
472 echo ./configure ${conf}
473 ./configure ${conf} || die "./configure failed"
474
475 prepare_directories ${QT4_TARGET_DIRECTORIES}
278} 476}
477
478# @FUNCTION: qt4-build_src_compile
479# @DESCRIPTION:
480# Actual compile phase
481qt4-build_src_compile() {
482 setqtenv
483
484 build_directories ${QT4_TARGET_DIRECTORIES}
485}
486
487# @FUNCTION: qt4-build_src_test
488# @DESCRIPTION:
489# Runs tests only in target directories.
490qt4-build_src_test() {
491 # QtMultimedia does not have any test suite (bug #332299)
492 [[ ${PN} == qt-multimedia ]] && return
493
494 for dir in ${QT4_TARGET_DIRECTORIES}; do
495 emake -j1 check -C ${dir}
496 done
497}
498
499# @FUNCTION: fix_includes
500# @DESCRIPTION:
501# For MacOS X we need to add some symlinks when frameworks are
502# being used, to avoid complications with some more or less stupid packages.
503fix_includes() {
504 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
505 # Some packages tend to include <Qt/...>
506 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
507
508 # Fake normal headers when frameworks are installed... eases life later on
509 local dest f h
510 for frw in "${D}${QTLIBDIR}"/*.framework; do
511 [[ -e "${frw}"/Headers ]] || continue
512 f=$(basename ${frw})
513 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
514 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
515
516 # Link normal headers as well.
517 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
518 h=$(basename ${hdr})
519 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
520 done
521 done
522 fi
523}
524
525# @FUNCTION: qt4-build_src_install
526# @DESCRIPTION:
527# Perform the actual installation including some library fixes.
528qt4-build_src_install() {
529 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
530 setqtenv
531
532 install_directories ${QT4_TARGET_DIRECTORIES}
533 install_qconfigs
534 fix_library_files
535 fix_includes
536
537 # remove .la files since we are building only shared Qt libraries
538 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
539}
540
541# @FUNCTION: setqtenv
542# @INTERNAL
543setqtenv() {
544 # Set up installation directories
545 QTPREFIXDIR=${EPREFIX}/usr
546 QTBINDIR=${EPREFIX}/usr/bin
547 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
548 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
549 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
550 QTHEADERDIR=${EPREFIX}/usr/include/qt4
551 QTPLUGINDIR=${QTLIBDIR}/plugins
552 QTIMPORTDIR=${QTLIBDIR}/imports
553 QTDATADIR=${EPREFIX}/usr/share/qt4
554 QTTRANSDIR=${QTDATADIR}/translations
555 QTSYSCONFDIR=${EPREFIX}/etc/qt4
556 QTEXAMPLESDIR=${QTDATADIR}/examples
557 QTDEMOSDIR=${QTDATADIR}/demos
558 QMAKE_LIBDIR_QT=${QTLIBDIR}
559 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
560
561 PLATFORM=$(qt_mkspecs_dir)
562
563 unset QMAKESPEC
564}
565
566# @FUNCTION: prepare_directories
567# @USAGE: < directories >
568# @INTERNAL
569# @DESCRIPTION:
570# Generates Makefiles for the given list of directories.
571prepare_directories() {
572 for x in "$@"; do
573 pushd "${S}"/${x} >/dev/null || die
574 einfo "Running qmake in: ${x}"
575 # avoid running over the maximum argument number, bug #299810
576 {
577 echo "${S}"/mkspecs/common/*.conf
578 find "${S}" -name '*.pr[io]'
579 } | xargs sed -i \
580 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
581 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
582 || die
583 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
584 popd >/dev/null || die
585 done
586}
587
279 588
280# @FUNCTION: build_directories 589# @FUNCTION: build_directories
281# @USAGE: < directories > 590# @USAGE: < directories >
591# @INTERNAL
282# @DESCRIPTION: 592# @DESCRIPTION:
283# Compiles the code in $QT4_TARGET_DIRECTORIES 593# Compiles the code in the given list of directories.
284build_directories() { 594build_directories() {
285 local dirs="$@"
286 for x in ${dirs}; do 595 for x in "$@"; do
287 cd "${S}"/${x} 596 pushd "${S}"/${x} >/dev/null || die
288 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 597 emake CC="$(tc-getCC)" \
289 emake || die "emake failed" 598 CXX="$(tc-getCXX)" \
599 LINK="$(tc-getCXX)" || die "emake failed"
600 popd >/dev/null || die
290 done 601 done
291} 602}
292 603
293# @FUNCTION: install_directories 604# @FUNCTION: install_directories
294# @USAGE: < directories > 605# @USAGE: < directories >
606# @INTERNAL
295# @DESCRIPTION: 607# @DESCRIPTION:
296# run emake install in the given directories, which are separated by spaces 608# Runs emake install in the given directories, which are separated by spaces.
297install_directories() { 609install_directories() {
298 local dirs="$@"
299 for x in ${dirs}; do 610 for x in "$@"; do
300 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 611 pushd "${S}"/${x} >/dev/null || die
301 emake INSTALL_ROOT="${D}" install || die "emake install failed" 612 emake INSTALL_ROOT="${D}" install || die "emake install failed"
302 popd >/dev/null || die "Can't popd from ${S}/${x}" 613 popd >/dev/null || die
303 done 614 done
304} 615}
305 616
306# @ECLASS-VARIABLE: QCONFIG_ADD 617# @ECLASS-VARIABLE: QCONFIG_ADD
307# @DESCRIPTION: 618# @DESCRIPTION:
308# List options that need to be added to QT_CONFIG in qconfig.pri 619# List options that need to be added to QT_CONFIG in qconfig.pri
309QCONFIG_ADD="${QCONFIG_ADD:-}" 620: ${QCONFIG_ADD:=}
310 621
311# @ECLASS-VARIABLE: QCONFIG_REMOVE 622# @ECLASS-VARIABLE: QCONFIG_REMOVE
312# @DESCRIPTION: 623# @DESCRIPTION:
313# List options that need to be removed from QT_CONFIG in qconfig.pri 624# List options that need to be removed from QT_CONFIG in qconfig.pri
314QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 625: ${QCONFIG_REMOVE:=}
315 626
316# @ECLASS-VARIABLE: QCONFIG_DEFINE 627# @ECLASS-VARIABLE: QCONFIG_DEFINE
317# @DESCRIPTION: 628# @DESCRIPTION:
318# List variables that should be defined at the top of QtCore/qconfig.h 629# List variables that should be defined at the top of QtCore/qconfig.h
319QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 630: ${QCONFIG_DEFINE:=}
320 631
321# @FUNCTION: install_qconfigs 632# @FUNCTION: install_qconfigs
633# @INTERNAL
634# @DESCRIPTION:
322# @DESCRIPTION: Install gentoo-specific mkspecs configurations 635# Install gentoo-specific mkspecs configurations.
323install_qconfigs() { 636install_qconfigs() {
324 local x 637 local x
325 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 638 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
326 for x in QCONFIG_ADD QCONFIG_REMOVE; do 639 for x in QCONFIG_ADD QCONFIG_REMOVE; do
327 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 640 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
328 done 641 done
329 insinto ${QTDATADIR}/mkspecs/gentoo 642 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
330 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 643 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
331 fi 644 fi
332 645
333 if [[ -n ${QCONFIG_DEFINE} ]]; then 646 if [[ -n ${QCONFIG_DEFINE} ]]; then
334 for x in ${QCONFIG_DEFINE}; do 647 for x in ${QCONFIG_DEFINE}; do
335 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 648 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
336 done 649 done
337 insinto ${QTHEADERDIR}/Gentoo 650 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
338 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 651 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
339 fi 652 fi
340} 653}
341 654
342# @FUNCTION: generate_qconfigs 655# @FUNCTION: generate_qconfigs
343# @DESCRIPTION: Generates gentoo-specific configurations 656# @INTERNAL
657# @DESCRIPTION:
658# Generates gentoo-specific qconfig.{h,pri}.
344generate_qconfigs() { 659generate_qconfigs() {
345 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 660 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
346 local x qconfig_add qconfig_remove qconfig_new 661 local x qconfig_add qconfig_remove qconfig_new
347 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 662 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
348 [[ -f ${x} ]] || continue 663 [[ -f ${x} ]] || continue
349 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 664 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
350 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 665 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
351 done 666 done
352 667
353 # these error checks do not use die because dying in pkg_post{inst,rm} 668 # these error checks do not use die because dying in pkg_post{inst,rm}
354 # just makes things worse. 669 # just makes things worse.
355 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 670 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
362 677
363 # generate list of QT_CONFIG entries from the existing list 678 # generate list of QT_CONFIG entries from the existing list
364 # including qconfig_add and excluding qconfig_remove 679 # including qconfig_add and excluding qconfig_remove
365 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 680 for x in $(sed -n 's/^QT_CONFIG +=//p' \
366 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 681 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
367 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 682 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
368 done 683 done
369 684
370 # replace the existing QT_CONFIG list with qconfig_new 685 # replace the existing QT_CONFIG list with qconfig_new
371 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 686 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
372 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 687 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
396 fi 711 fi
397 fi 712 fi
398} 713}
399 714
400# @FUNCTION: qt4-build_pkg_postrm 715# @FUNCTION: qt4-build_pkg_postrm
716# @DESCRIPTION:
401# @DESCRIPTION: Generate configurations when the package is completely removed 717# Regenerate configuration when the package is completely removed.
402qt4-build_pkg_postrm() { 718qt4-build_pkg_postrm() {
403 generate_qconfigs 719 generate_qconfigs
404} 720}
405 721
406# @FUNCTION: qt4-build_pkg_postinst 722# @FUNCTION: qt4-build_pkg_postinst
723# @DESCRIPTION:
407# @DESCRIPTION: Generate configuration, plus throws a message about possible 724# Regenerate configuration, plus throw a message about possible
408# breakages and proposed solutions. 725# breakages and proposed solutions.
409qt4-build_pkg_postinst() { 726qt4-build_pkg_postinst() {
410 generate_qconfigs 727 generate_qconfigs
411 echo
412 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
413 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
414 ewarn "should recompile the packages providing these plugins. Also, make sure you"
415 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
416 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
417 ewarn
418 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
419 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
420 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
421 ewarn "configuration."
422 ewarn
423 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
424 echo
425} 728}
426 729
427# @FUNCTION: skip_qmake_build_patch 730# @FUNCTION: skip_qmake_build
731# @INTERNAL
428# @DESCRIPTION: 732# @DESCRIPTION:
429# Don't need to build qmake, as it's already installed from qt-core 733# Patches configure to skip qmake compilation, as it's already installed by qt-core.
430skip_qmake_build_patch() { 734skip_qmake_build() {
431 # Don't need to build qmake, as it's already installed from qt-core
432 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 735 sed -i -e "s:if true:if false:g" "${S}"/configure || die
433} 736}
434 737
435# @FUNCTION: skip_project_generation_patch 738# @FUNCTION: skip_project_generation
739# @INTERNAL
436# @DESCRIPTION: 740# @DESCRIPTION:
437# Exit the script early by throwing in an exit before all of the .pro files are scanned 741# Exit the script early by throwing in an exit before all of the .pro files are scanned.
438skip_project_generation_patch() { 742skip_project_generation() {
439 # Exit the script early by throwing in an exit before all of the .pro files are scanned
440 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 743 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
441 -i "${S}"/configure || die "Sed failed"
442} 744}
443 745
444# @FUNCTION: symlink_binaries_to_buildtree 746# @FUNCTION: symlink_binaries_to_buildtree
747# @INTERNAL
445# @DESCRIPTION: 748# @DESCRIPTION:
446# Symlink generated binaries to buildtree so they can be used during compilation 749# Symlinks generated binaries to buildtree, so they can be used during compilation time.
447# time
448symlink_binaries_to_buildtree() { 750symlink_binaries_to_buildtree() {
449 for bin in qmake moc uic rcc; do 751 for bin in qmake moc uic rcc; do
450 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 752 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
451 done 753 done
452} 754}
453 755
454# @FUNCTION: fix_library_files 756# @FUNCTION: fix_library_files
757# @INTERNAL
455# @DESCRIPTION: 758# @DESCRIPTION:
456# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 759# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
457# moves the *.pc-files into the pkgconfig directory 760# moves the *.pc files into the pkgconfig directory.
458fix_library_files() { 761fix_library_files() {
762 local libfile
459 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 763 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
460 if [[ -e ${libfile} ]]; then 764 if [[ -e ${libfile} ]]; then
461 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 765 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
462 fi 766 fi
463 done 767 done
464 768
465 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 769 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
466 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 770 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
467 if [[ -e ${libfile} ]]; then 771 if [[ -e ${libfile} ]]; then
468 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 772 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
469 773
470 # Move .pc files into the pkgconfig directory 774 # Move .pc files into the pkgconfig directory
471 dodir ${QTPCDIR} 775 dodir ${QTPCDIR#${EPREFIX}}
472 mv ${libfile} "${D}"/${QTPCDIR}/ \ 776 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
473 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
474 fi 777 fi
475 done 778 done
476 779
477 # Don't install an empty directory 780 # Don't install an empty directory
478 rmdir "${D}"/${QTLIBDIR}/pkgconfig 781 rmdir "${D}"/${QTLIBDIR}/pkgconfig
479} 782}
480 783
481# @FUNCTION: qt_use 784# @FUNCTION: qt_use
482# @USAGE: < flag > [ feature ] [ enableval ] 785# @USAGE: < flag > [ feature ] [ enableval ]
483# @DESCRIPTION: 786# @DESCRIPTION:
484# This will echo "${enableval}-${feature}" if <flag> is enabled, or 787# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
485# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 788# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
486# will be used for that. If [enableval] is not specified, it omits the 789# will be used for that. If [enableval] is not specified, it omits the
487# assignment-part 790# "-${enableval}" part.
488qt_use() { 791qt_use() {
489 local flag="${1}" 792 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
490 local feature="${1}"
491 local enableval=
492
493 [[ -n ${2} ]] && feature=${2}
494 [[ -n ${3} ]] && enableval="-${3}"
495
496 if use ${flag}; then
497 echo "${enableval}-${feature}"
498 else
499 echo "-no-${feature}"
500 fi
501}
502
503# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
504# @DESCRIPTION:
505# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
506# (eutils.eclass), line per line.
507#
508# Example:
509# @CODE
510# pkg_setup() {
511# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
512# ~x11-libs/qt-gui-${PV} qt3support"
513# qt4-build_check_use
514# }
515# @CODE
516
517# Run built_with_use on each flag and print appropriate error messages if any
518# flags are missing
519
520_qt_built_with_use() {
521 local missing opt pkg flag flags
522
523 if [[ ${1} = "--missing" ]]; then
524 missing="${1} ${2}" && shift 2
525 fi
526 if [[ ${1:0:1} = "-" ]]; then
527 opt=${1} && shift
528 fi
529
530 pkg=${1} && shift
531
532 for flag in "${@}"; do
533 flags="${flags} ${flag}"
534 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
535 flags="${flags}*"
536 else
537 [[ ${opt} = "-o" ]] && return 0
538 fi
539 done
540 if [[ "${flags# }" = "${@}" ]]; then
541 return 0
542 fi
543 if [[ ${opt} = "-o" ]]; then
544 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
545 else
546 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
547 fi
548 return 1
549}
550
551# @FUNCTION: qt4-build_check_use
552# @DESCRIPTION:
553# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
554# USE flags listed.
555#
556# If any of the required USE flags are missing, an eerror will be printed for
557# each package with missing USE flags.
558qt4-build_check_use() {
559 local line missing
560 while read line; do
561 [[ -z ${line} ]] && continue
562 if ! _qt_built_with_use ${line}; then
563 missing=true
564 fi
565 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
566 if [[ -n ${missing} ]]; then
567 echo
568 eerror "Flags marked with an * are missing."
569 die "Missing USE flags found"
570 fi
571} 793}
572 794
573# @FUNCTION: qt_mkspecs_dir 795# @FUNCTION: qt_mkspecs_dir
574# @RETURN: the specs-directory w/o path 796# @RETURN: the specs-directory w/o path
575# @DESCRIPTION: 797# @DESCRIPTION:
576# Allows us to define which mkspecs dir we want to use. 798# Allows us to define which mkspecs dir we want to use.
577qt_mkspecs_dir() { 799qt_mkspecs_dir() {
578 # Allows us to define which mkspecs dir we want to use.
579 local spec 800 local spec=
580 801
581 case ${CHOST} in 802 case "${CHOST}" in
582 *-freebsd*|*-dragonfly*) 803 *-freebsd*|*-dragonfly*)
583 spec="freebsd" ;; 804 spec=freebsd ;;
584 *-openbsd*) 805 *-openbsd*)
585 spec="openbsd" ;; 806 spec=openbsd ;;
586 *-netbsd*) 807 *-netbsd*)
587 spec="netbsd" ;; 808 spec=netbsd ;;
588 *-darwin*) 809 *-darwin*)
810 if use aqua; then
811 # mac with carbon/cocoa
812 spec=macx
813 else
814 # darwin/mac with x11
589 spec="darwin" ;; 815 spec=darwin
816 fi
817 ;;
818 *-solaris*)
819 spec=solaris ;;
590 *-linux-*|*-linux) 820 *-linux-*|*-linux)
591 spec="linux" ;; 821 spec=linux ;;
592 *) 822 *)
593 die "Unknown CHOST, no platform choosen." 823 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
594 esac 824 esac
595 825
596 CXX=$(tc-getCXX) 826 case "$(tc-getCXX)" in
597 if [[ ${CXX/g++/} != ${CXX} ]]; then 827 *g++*)
598 spec="${spec}-g++" 828 spec+=-g++ ;;
599 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 829 *icpc*)
600 spec="${spec}-icc" 830 spec+=-icc ;;
601 else 831 *)
602 die "Unknown compiler ${CXX}." 832 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
833 esac
834
835 # Add -64 for 64bit profiles
836 if use x64-freebsd ||
837 use amd64-linux ||
838 use x64-macos ||
839 use x64-solaris ||
840 use sparc64-solaris
841 then
842 spec+=-64
603 fi 843 fi
604 844
605 echo "${spec}" 845 echo "${spec}"
606} 846}
607 847
608case ${EAPI:-0} in 848# @FUNCTION: qt_assistant_cleanup
609 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 849# @INTERNAL
850# @DESCRIPTION:
851# Tries to clean up tools.pro for qt-assistant ebuilds.
852# Meant to be called in src_prepare().
853# Since Qt 4.7.4 this function is a no-op.
854qt_assistant_cleanup() {
855 # apply patching to qt-assistant ebuilds only
856 [[ ${PN} != qt-assistant ]] && return
857
858 # no longer needed for 4.7.4 and later
859 version_is_at_least 4.7.4 && return
860
861 # different versions (and branches...) may need different handling,
862 # add a case if you need special handling
863 case "${MY_PV_EXTRA}" in
864 *kde-qt*)
865 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
866 -e "/mac/,/^embedded.*makeqpf$/d" \
867 -i tools/tools.pro || die "patching tools.pro failed"
868 ;;
869 *)
870 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
871 -e "/mac/,/^embedded.*makeqpf$/d" \
872 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
873 -i tools/tools.pro || die "patching tools.pro failed"
874 ;;
875 esac
876}
877
878# @FUNCTION: qt_nolibx11
879# @INTERNAL
880# @DESCRIPTION:
881# Ignore X11 tests for packages that don't need X libraries installed.
882qt_nolibx11() {
883 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
884 die "x11 check sed failed"
885}
886
610 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 887EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
611esac

Legend:
Removed from v.1.35  
changed lines
  Added in v.1.124

  ViewVC Help
Powered by ViewVC 1.1.20